#include <stdio.h>

int n;
typedef struct {
  int x1;
  int x2;
  int y1;
  int y2;
} bx;
bx box[110000];
int list[110000];

int splity(int *b, int bs, int p) {
  int l=0, r=0, i;
  for (i=0; i<bs; i++) {
    if (box[b[i]].y2<=p) l++;
    else if (box[b[i]].y1>=p) r++;
    else return 0;
  }
  if (r && l) return 1;
  else return 0;
}

int splitx(int *b, int bs, int p) {
  int l=0, r=0, i;
  for (i=0; i<bs; i++) {
    if (box[b[i]].x2<=p) l++;
    else if (box[b[i]].x1>=p) r++;
    else return 0;
  }
  if (r && l) return 1;
  else return 0;
}

int cmpy(int *a, int *b) {
  return box[*a].y1 - box[*b].y1;
}

int cmpx(int *a, int *b) {
  return box[*a].x1 - box[*b].x1;
}

bx *conc(int x1, int y1, int x2, int y2, int *b, int bs) {
  int i, j, cb;
  int lls, rls;
  int *ll;
  int *rl;
  bx *lr;
  bx *rr;
  bx *res;
  int lp, rp;

  if (bs==1) return 0;
  qsort(b, bs, sizeof(int), cmpy);
  cb = box[b[0]].y2;
  for (i=1; i<bs; i++) {
    if (box[b[i]].y1>=cb) break;
    if (box[b[i]].y2>cb) cb = box[b[i]].y2;
  }
  /*for (i=0; i<bs; i++) {
    if (box[b[i]].y1<cb && splity(b, bs, box[b[i]].y1)) cb = box[b[i]].y1;
    else if (box[b[i]].y2<cb && splity(b, bs, box[b[i]].y2)) cb = box[b[i]].y2;
    }*/
  if (i<bs) {
    ll = (int *)malloc(bs*sizeof(int));
    rl = (int *)malloc(bs*sizeof(int));
    lls = rls = 0;
    for (i=0; i<bs; i++) {
      if (box[b[i]].y2<=cb) ll[lls++] = b[i];
      else rl[rls++] = b[i];
    }
    lr = conc(x1, y1, x2, cb, ll, lls);
    rr = conc(x1, cb, x2, y2, rl, rls);
    res = (bx *)malloc(sizeof(bx)*bs);
    res[0].x1 = x1;
    res[0].x2 = x2;
    res[0].y1 = res[0].y2 = cb;
    lp = rp = 0;
    for (i=1; i<bs-1; i++) {
      if (rp==rls-1 || (lp<lls-1 && (lr[lp].x1<rr[rp].x1 || (lr[lp].x1==rr[rp].x1 && lr[lp].y1<rr[rp].y1))))
	res[i] = lr[lp++];
      else res[i] = rr[rp++];
    }
	free(ll); free(rl); free(lr); free(rr);
    return res;
  }

  qsort(b, bs, sizeof(int), cmpx);
  cb = box[b[0]].x2;
  for (i=1; i<bs; i++) {
    if (box[b[i]].x1>=cb) break;
    if (box[b[i]].x2>cb) cb = box[b[i]].x2;
  }
  /*for (i=0; i<bs; i++) {
    if (box[b[i]].x1<cb && splitx(b, bs, box[b[i]].x1)) cb = box[b[i]].x1;
    else if (box[b[i]].x2<cb && splitx(b, bs, box[b[i]].x2)) cb = box[b[i]].x2;
    }*/
  if (i<bs) {
    ll = (int *)malloc(bs*sizeof(int));
    rl = (int *)malloc(bs*sizeof(int));
    lls = rls = 0;
    for (i=0; i<bs; i++) {
      if (box[b[i]].x2<=cb) ll[lls++] = b[i];
      else rl[rls++] = b[i];
    }
    lr = conc(x1, y1, cb, y2, ll, lls);
    rr = conc(cb, y1, x2, y2, rl, rls);
    res = (bx *)malloc(sizeof(bx)*bs);
    res[0].y1 = y1;
    res[0].y2 = y2;
    res[0].x1 = res[0].x2 = cb;
    lp = rp = 0;
    for (i=1; i<bs-1; i++) {
      if (rp==rls-1 || (lp<lls-1 && (lr[lp].x1<rr[rp].x1 || (lr[lp].x1==rr[rp].x1 && lr[lp].y1<rr[rp].y1))))
	res[i] = lr[lp++];
      else res[i] = rr[rp++];
    }
	free(ll); free(rl); free(lr); free(rr);
    return res;
  }
  return 0;
}

int main(void) {
  int i;
  bx range;
  bx *res;

  scanf("%d", &n);
  range.x1 = 100000;
  range.y1 = 100000;
  range.x2 = -100000;
  range.y2 = -100000;
  for (i=0; i<n; i++) {
    scanf("%d %d %d %d", &box[i].x1, &box[i].y1, &box[i].x2, &box[i].y2);
    if (box[i].x1 < range.x1) range.x1 = box[i].x1;
    if (box[i].y1 < range.y1) range.y1 = box[i].y1;
    if (box[i].x2 > range.x2) range.x2 = box[i].x2;
    if (box[i].y2 > range.y2) range.y2 = box[i].y2;
    list[i] = i;
  }
  res = conc(range.x1, range.y1, range.x2, range.y2, list, n);
  printf("%d\n", n-1);
  for (i=0; i<n-1; i++) {
    printf("%d %d %d %d\n", res[i].x1, res[i].y1, res[i].x2, res[i].y2);
  }

  return 0;
}
