/*
TASK: treas
LANG: C
*/

#include <stdio.h>

int n;
typedef struct {
        int x;
        int y;
        int gain;
        int l;
        int r;
        int dummy;
} cell;
cell box[4096];

int best[4096];

int cmp(cell *a, cell *b) {
        return a->l - b->l;
}

int main(void) {
        int i, j, b, t;

        scanf("%d", &n);
        for (i=1; i<=n; i++) {
                scanf("%d %d %d", &box[i].x, &box[i].dummy, &box[i].gain);
                box[i].y = -box[i].dummy;
                box[i].l = box[i].x - (box[i].y - 1);
                box[i].r = box[i].x + (box[i].y - 1);
        }
        qsort(box+1, n, sizeof(cell), cmp);
        for (i=1; i<=n; i++) {
                best[i] = -2000000000;
                for (j=0; j<i; j++) {
                        if (j==0 || box[j].r < box[i].l) {
                                t = box[i].y * box[i].y;
                        } else if (box[j].r < box[i].r) {
                                t = box[j].r - box[i].l + 1;
                                if (t%2) t = (t/2+1)*(t/2+1);
                                else t = (t/2)*(t/2+1);
                                t = box[i].y * box[i].y - t;
                        } else t = 0;
                        t = best[j] + box[i].gain - t;
                        if (t>best[i]) best[i] = t;
                        if (j>0 && box[j].r>=box[i].r && t>best[j]) best[j] = t;
                }
        }
        b = 0;
        for (i=1; i<=n; i++) if (best[i]>b) b = best[i];
        printf("%d\n", b);

        return 0;
}
