#include <stdio.h>
#include <math.h>
#include <algorithm>

struct cennost
{
        int x,y,s;
        bool operator<(const cennost o) const
        {
                if (x-y == o.x-o.y) return y>o.y;
                return x-y < o.x-o.y;
        }
};

int sqr(int a) { return a*a; }
int min(int a, int b) { return a<b?a:b; }
int max(int a, int b) { return a>b?a:b; }

bool is_sub(cennost c1, cennost c2)
{
        return (c1.y>=c2.y && abs(c1.x-c2.x)<=c1.y-c2.y);
}

int digging(cennost c)
{
        return sqr(c.y);
}

int cross_dig(cennost c1, cennost c2)
{
        int mn, mx, result;
        mn = max(c1.x+c1.y+1, c2.x+c2.y+1);
        mx = min(c1.x-c1.y-1, c2.x-c2.y-1);
        if (mn>mx) return 0;
        if ((mx-mn)%2==0) result=sqr(1+(mx-mn)/2);
        else result=sqr(1+(mx-mn)/2) + (mx-mn+1)/2;
        return result;
}

int n;
cennost cs[1024];
int best;
int sol[1024];

int main(void)
{
        int j,i;
        scanf("%d",&n);
        for (i=0;i<n;i++)
        {
                scanf("%d %d %d", &cs[i].x, &cs[i].y, &cs[i].s);
        }
        std::sort(cs, cs+n);
        //for (i=0;i<n;i++)
        //      printf("--- %d %d %d\n", cs[i].x, cs[i].y, cs[i].s);
        best = 0;
        for (j=0;j<n;j++)
        {
                int pechalb = cs[j].s - digging(cs[j]);
                for (i=0;i<n;i++)
                {
                        if (i!=j && is_sub(cs[i],cs[j]))
                                pechalb+=cs[i].s;
                }
                sol[j] = pechalb;
                
                for (i=0;i<j;i++)
                {
                        if (i!=j && !is_sub(cs[i], cs[j]))
                        {
                                pechalb = cs[j].s + sol[i] + cross_dig(cs[j],cs[i]) - digging(cs[j]);
                                int a;
                                for (a=0;a<n;a++)
                                {
                                        if (a!=i && a!=j && is_sub(cs[a],cs[j]) && 
                                                !is_sub(cs[a],cs[i]))
                                        {
                                                pechalb+=cs[a].s;
                                        }
                                }
                                if (pechalb>sol[j]) sol[j]=pechalb;
                        }
                }

                //printf("%d ", sol[j]);

                if (sol[j]>best) best = sol[j];
        }
        printf("%d\n", best);
        return 0;
}

/*

3
2 -3 7
4 -3 7
3 -1 3

3
3 -3 9
4 -1 3
7 -3 9

2
11 -3 7
12 -3 7

2
1 -2 7
2 -3 7

11
10 -10 30
11 -10 30
12 -10 30
13 -10 30
14 -10 30
15 -10 30
16 -10 30
17 -10 30
18 -10 30
19 -10 30
20 -10 30



  */